# Module `mididings.util`

note_number(note)

  Convert note name to note number.

  Parameters:

    note – any valid note description (name or number).

  Returns:

    MIDI note number.

note_range(notes)

  Convert note range to note numbers.

  Parameters:

    notes – any valid note range (names or numbers, tuple or string). If this is a single note, the range containing only that note is returned.

  Returns:

    tuple of two MIDI note numbers.

note_name(note)

  Get note name from note number.

  Parameters:

    note – a MIDI note number.

  Returns:

    note name as a string.

controller_name(ctrl)

  Get controller description.

port_number(port)

  Convert port description to port number.

  Parameters:

    port – a port name or number.

  Returns:

    the port’s number.

class NoDataOffset(value)

  An integer type that’s unaffected by data offset conversions.

offset(n)

  Add current data offset.

actual(n)

  Subtract current data offset to get the “real” value used on the C++ side.